#include "app.h"

#include "pins.h"

#include <gtk/gtk.h>
#include <stdio.h>
#ifndef NO_WIRINGPI
#include <wiringPi.h>
#endif

/* BAD GLOBAL VARIABLES */

static GameApp* app = NULL;

/* PROTOTYPES!!! */

#ifndef NO_WIRINGPI
static int button_down_cb( void* pin );
static int button_up_cb( void* pin );
static void isr_g1();
static void isr_r1();
static void isr_g2();
static void isr_r2();
#endif

/* PUBLIC FUNK!!! */

int main( int argc, char** argv ) {

#ifndef NO_WIRINGPI

	wiringPiSetupPinType( WPI_PIN_BCM );

	pinMode( LED_G1, OUTPUT );
	pinMode( LED_R1, OUTPUT );
	pinMode( LED_G2, OUTPUT );
	pinMode( LED_R2, OUTPUT );
	pinMode( LED_G3, OUTPUT );
	pinMode( LED_R3, OUTPUT );
	pinMode( LED_G4, OUTPUT );
	pinMode( LED_R4, OUTPUT );

	digitalWrite( LED_G1, LOW );
	digitalWrite( LED_R1, LOW );
	digitalWrite( LED_G2, LOW );
	digitalWrite( LED_R2, LOW );
	digitalWrite( LED_G3, LOW );
	digitalWrite( LED_R3, LOW );
	digitalWrite( LED_G4, LOW );
	digitalWrite( LED_R4, LOW );

	pullUpDnControl( BUTTON_G1, PUD_UP );
	pullUpDnControl( BUTTON_R1, PUD_UP );
	pullUpDnControl( BUTTON_G2, PUD_UP );
	pullUpDnControl( BUTTON_R2, PUD_UP );

	wiringPiISR( BUTTON_G1, INT_EDGE_BOTH, &isr_g1 );
	wiringPiISR( BUTTON_R1, INT_EDGE_BOTH, &isr_r1 );
	wiringPiISR( BUTTON_G2, INT_EDGE_BOTH, &isr_g2 );
	wiringPiISR( BUTTON_R2, INT_EDGE_BOTH, &isr_r2 );

#endif

	app = game_app_new();
	int ret = g_application_run( G_APPLICATION( app ), argc, argv );

#ifndef NO_WIRINGPI

	digitalWrite( LED_G1, LOW );
	digitalWrite( LED_R1, LOW );
	digitalWrite( LED_G2, LOW );
	digitalWrite( LED_R2, LOW );
	digitalWrite( LED_G3, LOW );
	digitalWrite( LED_R3, LOW );
	digitalWrite( LED_G4, LOW );
	digitalWrite( LED_R4, LOW );

#endif

	return ret;

}

/* PRIVATE FUNK!!! */

#ifndef NO_WIRINGPI

static int button_down_cb( void* pin ) {

	game_app_button_press( app, *( (int*) pin ) );

	return G_SOURCE_REMOVE;

}

static int button_up_cb( void* pin ) {

	game_app_button_release( app, *( (int*) pin ) );

	return G_SOURCE_REMOVE;

}

static void isr_g1() {

	static int pin = BUTTON_G1;
	if ( HIGH == digitalRead( pin ) ) {
		g_idle_add( &button_up_cb, &pin );
	} else {
		g_idle_add( &button_down_cb, &pin );
	}

}

static void isr_r1() {

	static int pin = BUTTON_R1;
	if ( HIGH == digitalRead( pin ) ) {
		g_idle_add( &button_up_cb, &pin );
	} else {
		g_idle_add( &button_down_cb, &pin );
	}

}

static void isr_g2() {

	static int pin = BUTTON_G2;
	if ( HIGH == digitalRead( pin ) ) {
		g_idle_add( &button_up_cb, &pin );
	} else {
		g_idle_add( &button_down_cb, &pin );
	}

}

static void isr_r2() {

	static int pin = BUTTON_R2;
	if ( HIGH == digitalRead( pin ) ) {
		g_idle_add( &button_up_cb, &pin );
	} else {
		g_idle_add( &button_down_cb, &pin );
	}

}

#endif
